package com.nisum.paymentvendorsimulator.creditcard.services;

import com.nisum.paymentvendorsimulator.creditcard.domain.dto.*;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.stereotype.Service;

@Service
public class CreditCardService {

  private static final Logger logger = LoggerFactory.getLogger(CreditCardService.class);

  public CreditCardResponse authorize(CreditCardRequest ccRequest) {
    logger.info(String.valueOf(ccRequest));
    CreditCardResponse res = new CreditCardResponse();
    res.setCardNumber(ccRequest.getCard().getNumber());
    res.setCvv(ccRequest.getCard().getCvc());

    CreditCardAddress ccAddress = new CreditCardAddress("5708 Owens Dr", "APT 106","Pleasanton", "USA", "USA", "94588" );
    res.setBillingAddress(ccAddress);

    res.setAmount(ccRequest.getAmount().getValue());

    CreditCardAuthorizeResponse ccAR = new CreditCardAuthorizeResponse();
    CreditCardAdditionalData additionalData = new CreditCardAdditionalData();

    additionalData.setExpiryDate(ccRequest.getCard().getExpiryMonth() + "/" + ccRequest.getCard().getExpiryYear());
    ccAR.setAdditionalData(additionalData);
    ccAR.setPspReference("123");

    res.setCreditCardAuthorizeResponse(ccAR);

    return res;
  }
}
